Subject: Re: Git-hooks pre-push script does not receive input on stdin

From: Torsten Bögershausen <[email-masked]>
Date: Sun, 23 Mar 2014 08:19:47 +0100

On 2014-03-23 01.44, David Cowden wrote:
> http://stackoverflow.com/questions/22585091/git-hooks-pre-push-script-does-not-receive-input-via-stdin
> 
> Is this a bug in git?  Or am I just a shell noob?
> 
> Thanks in advance,
> 
> David

I assume that you have the right version of Git ?
You can look into the source of Git, to be more exact the test suite:
t/t5571-pre-push-hook.sh

When I play a little but with the script,
(Replace the diff with test_cmp, add a line:
diff --git a/t/t5571-pre-push-hook.sh b/t/t5571-pre-push-hook.sh
index 6f9916a..01db2fb 100755
--- a/t/t5571-pre-push-hook.sh
+++ b/t/t5571-pre-push-hook.sh
@@ -42,6 +42,7 @@ export COMMIT2
 write_script "$HOOK" <<'EOF'
 echo "$1" >actual
 echo "$2" >>actual
+echo hello >>actual
 cat >>actual
 EOF
-------------
and finally run it like this:

debug=t verbose=t ./t5571-pre-push-hook.sh  2>&1 | less
I get something like this:

--- expected    2014-03-23 07:15:58.000000000 +0000
+++ actual      2014-03-23 07:15:58.000000000 +0000
@@ -1,3 +1,4 @@
 parent1
 repo1
+hello
 refs/heads/master 139b20d8e6c5b496de61f033f642d0e3dbff528d refs/heads/foreign d79ce1670bdcb76e6d1da2ae095e890ccb326ae9
not ok 4 - push with hook
#       
#               git push parent1 master:foreign &&
#               test_cmp expected actual
#       
--------------------------------------------
So the question is, if your push simply doesn't have anything to push,
because everything is up to date?
And in this case there is nothing on STDIN?

If the problem still exists, feel free to post a script how to reproduce it
here to the list, t5571 may be a source of inspiration.